#ifndef TESTER_H
#define TESTER_H

#include "../../common/misc/misc_utils.h"
#include "../../common/platform/platform.h"
#include "../../core/strings/str8/str8.h"
#include <stdbool.h>

#ifdef __cplusplus
BEGIN_C_LINKAGE
#endif // __cplusplus

#define wapp_tester_result(PASSED) ((TestFuncResult){.name = wapp_str8_lit_ro(__func__), .passed = PASSED})
#define wapp_tester_run_tests(...) run_tests(__VA_ARGS__, NULL)

typedef struct test_func_result TestFuncResult;
struct test_func_result {
  Str8RO name;
  bool passed;

#ifdef WAPP_PLATFORM_WINDOWS
  wapp_misc_utils_padding_size(sizeof(Str8RO) + sizeof(bool));
#endif // WAPP_PLATFORM_WINDOWS
};

typedef TestFuncResult(TestFunc)(void);

void run_tests(TestFunc *func1, ...);

#ifdef __cplusplus
END_C_LINKAGE
#endif // __cplusplus

#endif // !TESTER_H
